<?php

namespace App\Providers;

use Illuminate\Support\Facades\RateLimiter;
use Illuminate\Foundation\Support\Providers\RouteServiceProvider as ServiceProvider;
use Illuminate\Support\Facades\Route;
use Illuminate\Http\Request;
use Illuminate\Cache\RateLimiting\Limit;

class RouteServiceProvider extends ServiceProvider
{
    /**
     * The path to your application's "home" route.
     *
     * Typically, users are redirected here after authentication.
     *
     * @var string
     */
    public const HOME = '/home';

    /**
     * Define your route model bindings, pattern filters, and other route configuration.
     */
    public function boot(): void
    {
        RateLimiter::for('api', function (Request $request) {
            return Limit::perMinute(150)->by($request->user()?->id ?: $request->ip());
        });

        $this->routes(function () {
            Route::middleware('api')
                ->prefix('api')
                ->group(base_path('routes/api.php'));

            //Created by : Hritik; Created at : 29 Jan 2024; Use : custom Customer api;
            Route::middleware('api')
                ->prefix('customer_api')
                ->group(base_path('routes/customer_api.php'));
            Route::middleware('api')
                ->prefix('restaurant_api')
                ->group(base_path('routes/restaurant_api.php'));

            Route::middleware('web')
                ->group(base_path('routes/web.php'));
        });
    }
}
